<?php
/*******************************************************************************************/
/*ANostra postboard*/
/*******************************************************************************************/
//error_reporting(E_ALL);
//ini_set('display_errors', 1);

if (strpos($_SERVER['HTTP_ACCEPT_ENCODING'], 'gzip') !== false) {// employ gzip compression
    ob_start("ob_gzhandler");
    header("Content-Encoding: gzip");
    header("Vary: Accept-Encoding");
} else { ob_start(); }

session_start();

include 'config.php';

//extract the Board name from the URL
$boardId = isset($_GET['b']) ? htmlspecialchars(trim($_GET['b'])) : '';

//config
//$amnesicChat  = $config['amnesicChat'];

//paths
$uploadsFilePath = $config['uploadsFilePath'];
$jsonsFilePath = $config['jsonsFilePath'];
$uploadsUserProfilePath = $config['uploadsUserProfilePath'];
$filePathSite = $config['filePathSite'];
	$filePathSiteImg = $filePathSite . '/' . $config['filePathSiteImg'];
	$filePathSiteEmotes = $filePathSite . '/' . $config['filePathSiteEmotes'];

$jsonFileMessages = $jsonsFilePath . '/' . $boardId . $config['jsonFileMessages'];
$jsonFileUsers = $jsonsFilePath . '/' . $config['jsonFileUsers'];
$jsonFilePostCounter = $jsonsFilePath . '/' . $boardId . $config['jsonFilePostCounter'];
$jsonFileUserCounter = $jsonsFilePath . '/' . $config['jsonFileUserCounter'];

// check if it exists, this software will NOT make board.json files
$boardId = preg_replace('/[^a-zA-Z0-9_-]/', '', $boardId);
if (!file_exists($jsonFileMessages) || !file_exists($jsonFilePostCounter)) {
    echo "The board " . $jsonFileMessages . " does not exist.";
    exit;
}

// define mapping for board specific CSS
$cssMapping = [
    'general' => 'style.css',
    //'technology' => 'technology-style.css',
    //default
];

// if the board has no css override use default
$selectedCssFile = $cssMapping[$boardId] ?? $cssMapping['default'];




/*******************************************************************************************/

require_once  'anostra_functions.php';

//begin document
?>

<html>
	<head>
		<!-- <link rel="stylesheet" href="CSS/style.css"> -->
		<link rel="stylesheet" href="CSS/<?php echo $selectedCssFile; ?>">
		<link rel="icon" type="image/x-icon" href="anostra.ico">
		<title>Anostra</title>
		<script> </script>
	</head>
	
	<body>
		<!-- chatboard image -->
		<div class="banner-container">
			<?php
				$totalGifs = 1;
				$randomGifNumber = rand(1, $totalGifs);
				$randomGifFile = $randomGifNumber . '.gif';
				$randomGifPath = $filePathSiteImg . DIRECTORY_SEPARATOR . $randomGifFile;
				echo '<img src="' . htmlspecialchars($randomGifPath) . '" class="banner" />';
				echo '<div class="white-border"><h1>' . ucfirst($boardId) . '</h1></div>';
			?>
		</div>

		<div class="white-border">
			<?php include 'board_list.php'; ?>
		</div>

			<table>
				<!-- display chat messages -->
				<?php foreach ($messages as $message): ?>
					<tr>
						<td>
							<p>
							(<?php echo $message['timestamp']; ?>) 
							[#<?php echo $message['post_number']; ?>]

							<?php
							if ($message['user_id'] !== null) {
								$profileImagePath = $uploadsUserProfilePath . '/' . $message['user_id'] . '.gif';
								if (file_exists($profileImagePath)) {
									echo '<img src="' . $profileImagePath . '" class="profile-pic">';
								}
							}
							?>

							<?php 
								if ($message['user_id'] !== NULL) {
									if($message['user_id'] === 1){//site mod identification
										echo '<span class="message-mention">' . $message['user_id'] . '</span>';
										echo '<span class="message-mention">' . $message['username'] . '</span>';
									} else {
										echo '<span class="bluetext">' . $message['user_id'] . '</span>';
										echo '<span class="redtext">' . $message['username'] . '</span>';
									}
								}
							?> :

							<?php 
								if (isset($message['deleted'])) {
									echo '<span class="deleted">' . formatMessage($message['message']) . '</span>';
								} else {
									echo formatMessage($message['message']);
								}
							?>
							
							</p>
						</td>
					</tr>
				<?php endforeach; ?>
			</table>



		<div class="bottom-forms">


			<!-- message form -->
			<form method="post">
				<div class="white-border">
					<label for="message">Message:</label>
					<input type="submit" value="Send">
				
				<textarea id="message" name="message" rows="3" cols="80" maxlength="4096" required></textarea>
				
				<!--<label for="file">File:</label>
				<input type="file" id="file" name="file">
				<br>-->
				</div>
			</form>

			<?php
            $isJanny = isset($_SESSION['user']['mod']) && $_SESSION['user']['mod'] == 1;

            if ($isJanny):
            ?>
				<div class="white-border">
					<form method="post">
						<label for="post_number_to_delete">Delete Post Number:</label>
						<input type="number" name="post_number_to_delete" id="post_number_to_delete" required>

						<label for="delete_reason">Reason for deletion:</label>
						<input type="text" name="delete_reason" id="delete_reason">

						<input type="submit" value="Delete">
					</form>

					<form method="post">
						<label for="user_id_to_ban">Ban User ID:</label>
						<input type="number" name="user_id_to_ban" id="user_id_to_ban" required>
						<input type="submit" value="Ban">
					</form>
				</div>
				<br>
			<?php
            endif;

            //message deletion
            if ($_SERVER['REQUEST_METHOD'] === 'POST' && isset($_POST['post_number_to_delete']) && $isJanny) {
                $postNumberToDelete = $_POST['post_number_to_delete'];
                $deleteReason = isset($_POST['delete_reason']) ? $_POST['delete_reason'] : "No reason provided";

                //remove message with given post number
                foreach ($messages as $key => $message) {
                    if ($message['post_number'] == $postNumberToDelete) {
                        if ($message['user_id'] != 1) { //user 1 unbannable
                            $messages[$key]['message'] = "MESSAGE DELETED: " . $deleteReason;
                            $messages[$key]['deleted'] = true;
                        }
                        break;
                    }
                }
                writeJsonFile($jsonFileMessages, $messages);
                header('Location: ' . $_SERVER['PHP_SELF'] . "?b=" . $boardId);
                exit;
            }

            // banning
            if ($_SERVER['REQUEST_METHOD'] === 'POST' && isset($_POST['user_id_to_ban']) && $isJanny) {
                $userIdToBan = $_POST['user_id_to_ban'];

                if ($userIdToBan != 1) { //user 1 unbannable
                    // remove user's profile picture from storage
                    $profilePicturePath = $uploadsUserProfilePath . '/' . $userIdToBan . '.gif';
                    if (file_exists($profilePicturePath)) {
                        unlink($profilePicturePath);
                    }

                    // remove user
                    /*foreach ($users as $key => $user) {
                        if ($user['user_id'] == $userIdToBan) {
                            unset($users[$key]);
                        }
                    }*/
					
                    writeJsonFile($jsonFileUsers, $users);
                }

                header('Location: ' . $_SERVER['PHP_SELF'] . "?b=" . $boardId);
                exit;
            }
            ?>


			<div class="white-border">
				<?php if (isset($_SESSION['user'])): ?>

				<p>Logged in as: <?php echo $_SESSION['user']['username'] . ' #' . $_SESSION['user']['user_id']; ?></p>

				<?php endif; ?>

				<?php if (!isset($_SESSION['user'])): ?>
					<!-- login form -->
					<form method="post">
						<input type="hidden" name="login" value="1">
						<label for="username">Username:</label>
						<input type="text" name="username" required>

						<label for="password">Password:</label>
						<input type="password" name="password" required>

						<label for="user_id">UID:</label>
						<input type="number" name="user_id" required>

						<input type="submit" value="Login">
					</form>
				<?php else: ?>
					<!-- logout option -->
					<form method="post">
						<input type="hidden" name="logout" value="1">
						<input type="submit" value="Logout">
					</form>
				<?php endif; ?>
			</div>

		
			<!--links-->
			<br>
			<div class="white-border">
				<div class="scroll-container">
					<a href="signup.php">Create username.</a>
					<a href="info.php">Info.</a>
				</div>
			</div>

		
		</div>



	</body>
</html>

<?php
ob_end_flush();//end output buffering and send the content to the client
?>